import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import loa.biz.ILOAApp;
import loa.biz.LOAApp;
import loa.biz.LOAFormList;
import loa.biz.LOAQueryInfo;
import loa.models.LOADataObject;
import loa.models.LOARawValue;

public class TestMain
{
    //依赖的jar有
    //commons-beanutils-1.8.3.jar
    //commons-collections-3.2.1.jar
    //commons-lang-2.4.jar
    //commons-logging-1.2.jar
    //ezmorph-1.0.6.jar
    //httpclient-4.4.jar
    //httpcore-4.4.jar
    //httpmime-4.4.jar
    //Java-WebSocket-1.3.9.jar
    //json-lib-2.4-jdk15.jar
    static String appName = "206a8faf-9a6b-4d94-a519-33bf94ab53c0";
    static String appKey = "9cb7291e-2b4f-4f5d-8096-5a24d8cf0b43";

    static ILOAApp vApp = null;

    public static void main(String[] args)
    {
        System.setProperty("loaOpenApi.logLevel", "debug");
        vApp = LOAApp.getInstance();
        try
        {
            vApp.init("http://192.168.1.218:888/10001/openapi/1.0", appName, appKey, true);
            vApp.login("admin", "admin");

            //---------------------------------------------------------------------
            //查询模板的数据接口demo
            LOAQueryInfo queryInfo = vApp.createQueryInfo();
            queryInfo.getParamValueList().add("申请单号", "QJD2101090007");

            LOAFormList formList = vApp.query("请假申请单", "查询指定单据(申请单号)", queryInfo);

            for (int i = 0; i < formList.count(); i++)
            {
                LOADataObject obj = formList.get(i);
                LOARawValue obj1 = obj.getRawValue("申请单号");
                LOARawValue obj2 = obj.getRawValue("请假天数");
                System.out.println("申请单号:" + obj1.get().toString());
                System.out.println("请假天数:" + obj2.get().toString());
            }

            //-----------------------------------------------------------
            //            //查询全局数据接口demo-----获取单点登录用户信息(应用名称,授权令牌)
            //            LOAQueryInfo queryInfo = vApp.createQueryInfo();
            //            queryInfo.getParamValueList().add("应用名称", "hr");
            //            queryInfo.getParamValueList().add("授权令牌", "c7a73c11-99b3-4fcc-bc47-b9a2e94086f1");
            //
            //            LOAFormList formList = vApp.query(null, "获取单点登录用户信息(应用名称,授权令牌)", queryInfo);
            //
            //            if (formList.count() > 0)
            //            {
            //                System.out.println("用户信息获取成功");
            //                LOADataObject obj = formList.get(0);
            //                System.out.println("账号:" + obj.getRawValue("账号"));
            //                System.out.println("姓名:" + obj.getRawValue("姓名"));
            //                System.out.println("电话:" + obj.getRawValue("电话"));
            //                System.out.println("编号:" + obj.getRawValue("编号"));
            //                System.out.println("第三方账号:" + obj.getRawValue("第三方账号"));
            //            }

            //-----------------------------------------------------------
            //新建表单demo1
            //            LOAFormDataObject vObj = vApp.newFormDataObject("提交设备");
            //            vObj.addRawValue("operation_id", "aaa111");
            //            vObj.addRawValue("operation_type", "aaa111");
            //            vObj.addRawValue("object_name", "aaa111");
            //            vObj.addRawValue("object_id", "1");
            //            vObj.addRawValue("operation_time", getFormatDateTimeStr(new Date()));
            //            vObj.addRawValue("ex_data", new Date().getTime() + "");
            //            vObj.save();

            //新建表单demo2
            //            LOAFormDataObject vObj = vApp.newFormDataObject("测试1号");
            //            //            vObj.addRawValue("设备卡号", "ceshi");
            //            //            vObj.addRawValue("设备编号", "111111");
            //            vObj.save();
            //            System.out.println(vObj.saveToJsonStr());

            //-------------------------------------------------------------
            //上传单元格图片demo
            //            File file = new File("D:\\用户目录\\我的图片\\微信图片_20200313182206.png");
            //            LOAFormFile file1 = null;
            //            //方式一
            //            file1 = vApp.postFormFile("测试单元格图片", "png", file);
            //            //方式二
            //            //InputStream in = new FileInputStream(file);
            //            //file1 = vApp.postFormFile("测试单元格图片", "png", in);
            //
            //            LOAFormDataObject obj = vApp.getFormDataObject("测试单元格图片", "1");
            //            obj.addAttachmentValue("图片", file1.getObjectID(), file.getName(), "png", file.getPath());
            //            obj.save();

            //-----------------------------------------------------------------
            //下载单元格图片demo
            //            LOAFormDataObject obj = vApp.getFormDataObject("测试单元格图片", "1");
            //            LOADataObject dataObj = obj.getObjectValue("图片");//获取指定字段值
            //            LOAFormAttachmentDataObject attachmentDataObj = obj.getFormCellAttachmentDataObj(dataObj);
            //            //
            //            if (null != attachmentDataObj)
            //            {
            //                //下载附件
            //                vApp.downloadFile(attachmentDataObj);
            //                String suffix = "." + attachmentDataObj.getType();
            //                //转换成文件
            //                asFile(attachmentDataObj.getAttachment(), suffix);
            //                //关闭流，必须要调用close，如果不调用 链接不会关闭
            //                attachmentDataObj.close();
            //            }

            //----------------------------------------------------------------------
            //下载附件接口
            //            LOAFormDataObject obj = vApp.getFormDataObject("test图片", "1");
            //
            //            //获取指定附件ID对象
            //            LOAFormAttachmentDataObject attachmentDataObj = obj.getAttachmentDataObj("501");
            //
            //            if (null != attachmentDataObj)
            //            {
            //                //下载附件
            //                vApp.downloadFile(attachmentDataObj);
            //                //转换成文件
            //                asFile(attachmentDataObj.getAttachment(), attachmentDataObj.getType());
            //                //关闭流，必须要调用close，如果不调用 链接不会关闭
            //                attachmentDataObj.close();
            //            }

            //                        LOAFormDataObject obj = vApp.getFormDataObject("device_setting", "501");
            //
            //            obj.delete();

            //                        LOAQueryInfo queryInfo = vApp.createQueryInfo();
            //                        queryInfo.getPageInfo().setPageCount(pageCount);

            //---------------------------------------------------------------------------
            //添加用户角色
            //            List<Object> roleList = new ArrayList<Object>();
            //            JSONObject obj = new JSONObject();
            //            obj.put("objectId", 4);
            //            roleList.add(obj);
            //            //新建用户
            //            String pwd = "222222";
            //            String newPwd = MD5Util.string2MD5(pwd).toUpperCase();
            //            LOAFormDataObject formDataObj = vApp.newFormDataObject("users");
            //            formDataObj.addRawValue("account", "test_13");
            //            formDataObj.addRawValue("password", newPwd);
            //            formDataObj.addRawValue("name", "v22Name33");
            //            formDataObj.addRawValue("email", "aa@qq.com");
            //
            //            formDataObj.addRawValue("roleList", roleList);
            //
            //            formDataObj.save();
            //

            //-----------------------------------------------------------------------
            //修改用户密码
            //            String newPwd = MD5Util.string2MD5("222222").toUpperCase();
            //            LOAFormDataObject formDataObj = vApp.getFormDataObject("users", "15");
            //            formDataObj.safeGetObjectListtValue("password");
            //            formDataObj.addRawValue("password", newPwd);
            //            formDataObj.save();

            //------------------------------------------------------------------------
            //更新用户角色，岗位，部门 
            //            String newPwd = MD5Util.string2MD5("222222").toUpperCase();
            //            //修改用户角色
            //            List<Object> roleList = new ArrayList<Object>();
            //            JSONObject obj = new JSONObject();
            //            obj.put("objectId", 6);
            //            roleList.add(obj);
            //
            //            JSONObject postObj = new JSONObject();
            //            postObj.put("latoId", "2");
            //            List<Object> postList = new ArrayList<Object>();
            //            postList.add(postObj);
            //
            //            List<Object> orgList = new ArrayList<Object>();
            //            JSONObject orgObj = new JSONObject();
            //            orgObj.put("objectId", "2");
            //
            //            //            orgObj.put("postList", postList);
            //            orgList.add(orgObj);
            //
            //            LOAFormDataObject formDataObj = vApp.getFormDataObject("users", "24");
            //            formDataObj.safeGetObjectListtValue("password");
            //            formDataObj.addRawValue("password", newPwd);
            //            formDataObj.addRawValue("roleList", roleList);
            //            formDataObj.addRawValue("orgList", orgList);
            //            formDataObj.addRawValue("mainDepartmentId", "2");//设置主部门ID
            //            formDataObj.save();

            //---------------------------------------------------------------------
            //上传附件与保存表单
            //            File file = new File("F:\\test\\b.txt");
            //            InputStream in = new FileInputStream(file);
            //            LOAFormFile file1 = vApp.postFormFile("测试去空格", "txt", in);
            //
            //            LOAFormDataObject vObj = vApp.getFormDataObject("测试去空格", "104");
            //            System.out.println("附件ID：" + file1.getObjectID());
            //            LOADataObject v = vObj.AddAttachment("a.txt");
            //            v.addRawValue("文件ID", file1.getObjectID());
            //            v.addRawValue("文件名", file.getName());
            //            v.addRawValue("类型", ".txt");
            //            v.addRawValue("大小", file.length() + "");
            //            vObj.save();

            //----------------------------------------------------------
            //获取指定表单的明细表数据 demo
            //            LOAFormDataObject vObj = vApp.getFormDataObject("微信群邀请链接", "5");
            //            System.out.println(JSONObject.fromObject(vObj));
            //            System.out.println(vObj.saveToJsonStr());
            //            LOADataObjectList list = vObj.findObjectListValue("明细");
            //            int count = list.count();
            //            for (int i = 0; i < count; i++)
            //            {
            //                LOADataObject deativ = list.get(i);
            //
            //                LOARawValue v1 = deativ.safeGetRawValue("a1");
            //                LOARawValue v2 = deativ.safeGetRawValue("a2");
            //                System.out.println(v1.get().toString() + "," + v2.get().toString());
            //            }

            //----------------------------------------------------------------------------
            //获取总表数据demo
            //            LOAFormList vObjList2 = vApp.getFormList("测试查询1");
            //            System.out.println(vObjList2.getCount());
            //            System.out.println(vObjList2.get(0).saveToJsonStr());
            //            // 创建查询对象(分页)
            //            LOAQueryInfo queryInfo = vApp.createQueryInfo();
            //            queryInfo.getSortInfoList().add("latoId", false);//创建顺序排序(oracle等数据库必须加上,不然每次分页拿到的数据有可能会重复)
            //            queryInfo.getPageInfo().setPageSize(2); //每页数量
            //
            //            LOAFormList vObjList = vApp.getFormList("微信群邀请链接", queryInfo);
            //            //
            //            LOAPageInfo vPageInfo = vObjList.getPageInfo();
            //            //
            //            System.out.println("总数量：" + vPageInfo.getTotal() + ",总页数:" + vPageInfo.getPageCount() + ",当前页数:"
            //                    + vPageInfo.getPageIndex() + ",每页数量:" + vPageInfo.getPageSize());
            //            for (int i = 0; i < vObjList.getCount(); i++)
            //            {
            //                LOADataObject vSubObj = vObjList.get(i);
            //                LOARawValue value = vSubObj.getRawValue("邀请链接");
            //                System.out.println(i + ". objID:" + vSubObj.getObjectID() + ", sss:" + value.get());
            //            }
            //            int pageCount = vPageInfo.getPageCount(); //总页数
            //            if (vPageInfo.getPageCount() > 1)
            //            {
            //                for (int j = 1; j < pageCount; j++)
            //                {
            //                    queryInfo.getPageInfo().setPageIndex(j); //要请求的页码
            //                    queryInfo.getPageInfo().setPageSize(2); //每页数量
            //                    vObjList = vApp.getFormList("微信群邀请链接", queryInfo);
            //                    for (int i = 0; i < vObjList.getCount(); i++)
            //                    {
            //                        LOADataObject vSubObj = vObjList.get(i);
            //                        LOARawValue value = vSubObj.getRawValue("邀请链接");
            //                        System.out.println(i + ". objID:" + vSubObj.getObjectID() + ", sss:" + value.get());
            //                    }
            //                }
            //            }

            //--------------------------------------------------------
            //调用总表查询过滤demo
            //            LOAQueryInfo queryInfo = vApp.createQueryInfo();
            //            // 创建查询对象的过滤项（对一个查询对象，可以添加多个数据项的查询）
            //            LOAFilterItem vFilterItem = queryInfo.getFilterList().add("假别");
            //            // 过滤项配置过滤信息(对一个数据项，可以设置多个查询值项)
            //            LOAFilterExpressionItem vFilterValueItem = vFilterItem.getExpressionList().add();
            //            vFilterValueItem.IsAnd = true;
            //            vFilterValueItem.Operator = FilterOperator.Equal; // 等于空
            //            vFilterValueItem.Value = "事假";
            //
            //            LOAFormList vObjList = vApp.getFormList("请假申请单", queryInfo);
            //            for (int i = 0; i < vObjList.getCount(); i++)
            //            {
            //                LOADataObject vSubObj = vObjList.get(i);
            //                LOARawValue value = vSubObj.getRawValue("请假天数");
            //                System.out.println(i + ". objID:" + vSubObj.getObjectID() + ", sss:" + value.get());
            //            }
            //            vObjList = vApp.getFormList("请假申请单");
            //            LOAPageInfo vPageInfo = vObjList.getPageInfo();
            //            System.out.println("返回数量：" + vPageInfo.getTotal());

            //--------------------------------------------------------
            //表单新建编辑删除demo
            //            LOAFormDataObject vObj = null;
            //
            //            // 新建表单demo
            //            vObj = vApp.newFormDataObject("模块分类");
            //            vObj.addRawValue("编号", "001");
            //            vObj.save();
            //            value = vObj.getRawValue("编号");
            //            System.out.println("编号:" + value.get());
            //
            //            // 删除表单demo
            //            obj = app.getFormDataObject("模块分类", "102");
            //            if (null != obj)
            //                obj.delete();
            //
            //            // 编辑表单demo
            //            vObj = vApp.getFormDataObject("模块分类", "1");
            //            LOARawValue value = vObj.getRawValue("编号");
            //            System.out.println("编号:" + value.get());
            //            value.set("去拉拉");
            //            vObj.save();
            //            // 检查保存成功没有
            //            value = vObj.getRawValue("编号");
            //            System.out.println("编号:" + value.get());

            //---------------------------------------------------------------------
            //查询模板表结构列表demo//需要服务器版本3.3.45.41以上版本才支持
            //            LOATemplateTable templateTable = vApp.getFormTemplateTableList("请假申请单");
            //
            //            System.out.println("主表名称：" + templateTable.getTableCaption());
            //
            //            List<LOATemplateTableField> fieldList = templateTable.getFieldList();
            //
            //            if (null != fieldList)
            //                for (LOATemplateTableField loaTemplateTableField : fieldList)
            //                {
            //                    System.out.println("字段名称：" + loaTemplateTableField.getName());
            //                    System.out.println("字段caption：" + loaTemplateTableField.getCaption());
            //                    System.out.println("字段类型：" + loaTemplateTableField.getType().getValue());
            //                    System.out.println("字段对象：" + JSONObject.fromObject(loaTemplateTableField).toString());
            //                }
            //
            //            List<LOATemplateTable> childTableList = templateTable.getChildTableList();
            //            if (null != childTableList)
            //            {
            //                for (LOATemplateTable loaTemplateTable : childTableList)
            //                {
            //
            //                    System.out.println("明细表名称：" + loaTemplateTable.getTableCaption());
            //
            //                    List<LOATemplateTableField> childFieldList = loaTemplateTable.getFieldList();
            //
            //                    if (null != childFieldList)
            //                        for (LOATemplateTableField loaTemplateTableField : childFieldList)
            //                        {
            //                            System.out.println("字段名称：" + loaTemplateTableField.getName());
            //                            System.out.println("字段caption：" + loaTemplateTableField.getCaption());
            //                            System.out.println("字段类型：" + loaTemplateTableField.getType().getValue());
            //                            System.out.println("字段对象：" + JSONObject.fromObject(loaTemplateTableField).toString());
            //                        }
            //                }
            //            }

            //---------------------------------------------------------------------------------------
            //获取指定模板的明细表查询过滤demo//需要服务器版本3.3.45.41以上版本才支持
            //            LOAQueryInfo queryInfo = vApp.createQueryInfo();
            //            //            // 创建查询对象的过滤项（对一个查询对象，可以添加多个数据项的查询）
            //            //            LOAFilterItem vFilterItem = queryInfo.getFilterList().add("内容");
            //            //            // 过滤项配置过滤信息(对一个数据项，可以设置多个查询值项)
            //            //            LOAFilterExpressionItem vFilterValueItem = vFilterItem.getExpressionList().add();
            //            //            vFilterValueItem.IsAnd = true;
            //            //            vFilterValueItem.Operator = FilterOperator.Equal; // 等于空
            //            //            vFilterValueItem.Value = "2";
            //
            //            LOAFormList vObjList = vApp.getFormDetailList("测试文本列表", "明细", queryInfo);
            //            System.out.println("明细总数量：" + vObjList.getPageInfo().getTotal());
            //            for (int i = 0; i < vObjList.getCount(); i++)
            //            {
            //                LOADataObject vSubObj = vObjList.get(i);
            //                LOARawValue value = vSubObj.getRawValue("内容");
            //                System.out.println(i + ". formID:" + vSubObj.getRawValue(LOADataObject._JSON_FormID) + ", objID:"
            //                        + vSubObj.getObjectID() + ", sss:" + value.get());
            //            }

            //-------------------------
            //插件登录demo
            //vApp.setPluginType("loginplugin_ldap");
            //            vApp.login("bbjy", "bbjy123456"); //正常加密登录
            //            vApp.login("datafocus", "datafocus2019", "md5");//使用sha1密码加密验证
        } catch (Exception e)
        {
            e.printStackTrace();
        } finally
        {
            //可以把该对象放在全局中使用,没有必要每次都初始化又退出登录
            //vApp.safeLogout();
        }

    }

    private static File asFile(InputStream inputStream, String fileType) throws IOException
    {
        File tmp = File.createTempFile("test", fileType, new File("F:\\test\\"));
        OutputStream os = new FileOutputStream(tmp);
        int bytesRead = 0;
        byte[] buffer = new byte[8192];
        while ((bytesRead = inputStream.read(buffer, 0, 8192)) != -1)
        {
            os.write(buffer, 0, bytesRead);
        }
        inputStream.close();
        return tmp;
    }

}
